/**
 * 
 */
package costo.kml2java.framework.test;

import java.util.HashMap;

/**
 * @author ardourel-g
 * 
 */
public class CompositeProvider implements IDataInjector {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private HashMap<String, IDataInjector> messagemap = new HashMap<String, IDataInjector>();

	/**
	 * @see costo.kml2java.framework.test.IDataInjector#isExact()
	 */
	@Override
	public boolean isExact() {
		// TODO Auto-generated method stub
		return false;
	}

	/**
	 * @see costo.kml2java.framework.test.IDataInjector#giveObjects(java.lang.Class<?>[])
	 */
	@Override
	public Object[] giveObjects(Class<?>[] classes) {
		// TODO Auto-generated method stub
		return null;
	}

	/**
	 * @see costo.kml2java.framework.test.IDataInjector#giveNamedObjects(java.lang.String, java.lang.Class<?>[])
	 */
	@Override
	public Object[] giveNamedObjects(String name, Class<?>[] classes) {
		// TODO Auto-generated method stub
		return this.messagemap.get(name).giveNamedObjects(name, classes);
	}

	/**
	 * @see costo.kml2java.framework.test.IDataInjector#giveObject(java.lang.Class)
	 */
	@Override
	public Object giveObject(Class<?> clazz) {
		// TODO Auto-generated method stub
		return null;
	}

	/**
	 * @see costo.kml2java.framework.test.IDataInjector#giveNamedObject(java.lang.String, java.lang.Class)
	 */
	@Override
	public Object giveNamedObject(String message, Class<?> clazz) {

		return this.messagemap.get(message).giveNamedObject(message, clazz);
	}

	/**
	 * @see costo.kml2java.framework.test.IDataInjector#reset()
	 */
	@Override
	public void reset() {
		for (IDataInjector di : this.messagemap.values()) {
			di.reset();
		}
	}

	/**
	 * @param key
	 * @param value
	 * @return
	 * @see java.util.HashMap#put(java.lang.Object, java.lang.Object)
	 */
	public IDataInjector putInjector(String key, IDataInjector value) {
		return messagemap.put(key, value);
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("CompositeProvider [messagemap=");
		builder.append(messagemap);
		builder.append("]");
		return builder.toString();
	}

	/**
	 * @return the messagemap
	 */
	public HashMap<String, IDataInjector> getMessagemap() {
		return messagemap;
	}

}
