package costo.kml2java.framework.test;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import costo.kml2java.framework.IService;
import costo.kml2java.framework.ProvidedService;
import costo.kml2java.framework.IServiceEvolutionListener;
import costo.kml2java.framework.channels.IChannel;

/**
 * 
 * runs testcases on services <br>
 * TODO : timout <br>
 * TODO : verify levels <br>
 * TODO : generate report <br>
 * TODO : assign logs <br>
 * 
 * @author ardourel-g
 * 
 */
public class ServTestCase implements IServiceEvolutionListener {

	private ServTestCaseData data;
	ProvidedService target;

	// expected results and verif level
	private Map<String, IChannel> oldChannels = new HashMap<String, IChannel>();

	// private Scheduler savedScheduler;

	protected void applyEnvironmement() {

		// for every mapping, look for a corresponding channel (queue) and replace him with a new randomChannel
		for (Map.Entry<String, IDataInjector> dataEntry : data.getDatachannelMapping().entrySet()) {

			String key = dataEntry.getKey();
			if (key.startsWith("_")) {
				// System.out.println("replacing " + key);

				// MessageQueueChannel queue = (MessageQueueChannel) oldChannels.get(key);
				// System.out.println("old is" + queue);
				// FIXME target.putChannel(key, new RandomChannel(queue.getCalled(), dataEntry.getValue()));
			}
		}

		((InjectorChannel) target.getChannel()).setCaller(target);
		// System.out.println(target.getChannels());

	}

	/**
	 * FIXME: PA commented code => does not work
	 */
	private void adjustScheduler() {
		// Injector for Scheduler is a sequence of seed, delay, timeout

		int seed = 0;
		int delay = 10;
		int timeout = 1000;// global timeout for the service (could be set for each transaction by modifying the messageQueueChannels)
		IDataInjector sched = data.getDatachannelMapping().get("scheduler");
		if (sched != null) {
			seed = (Integer) sched.giveObject(Integer.class);
			delay = (Integer) sched.giveObject(Integer.class);
			timeout = (Integer) sched.giveObject(Integer.class);
		}

		// FIXME this.savedScheduler = target.getSched();
		// Scheduler sched2 = new Scheduler(target.getLTS(), delay, 100000, timeout);
		// sched2.setSeed(seed);
		// // FIXME target.setSched(sched2);
	}

	private void saveChannels() {
		oldChannels.clear();
		// FIXME oldChannels.putAll(target.getChannels());
		// System.out.println("saved_chans" + oldChannels);

	}

	private void restoreChannels() {
		// FIXME target.getChannels().clear();
		// FIXME target.getChannels().putAll(oldChannels);

	}

	// should be separated in order to run the same test case in multiple mutants
	public void load(ProvidedService targ, String casefilename) {
		try {
			loadInjectorMapping(casefilename);
		} catch (Exception e) {
			e.printStackTrace();
			return;
		}
		target = targ;
		saveChannels();
		adjustScheduler();
		try {
			data.initComp(target.getOwner());
		} catch (SecurityException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NoSuchFieldException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		applyEnvironmement();
		target.addServiceListener(this);
	}

	public void run(ProvidedService targ, String casefilename) {
		load(targ, casefilename);
		// FIXME another mode now target.start();

	}

	// private void restoreScheduler() {
	// target.setSched(savedScheduler);
	// }

	private void generateReport() {

	}

	protected void loadInjectorMapping(String filename) throws IOException {
		data = new ServTestCaseData(filename);
	}

	@Override
	public void serviceError(IService serv, IChannel source, String message) {
		//FIXME to improve
		//System.out.println("--SERV-error>> "+serv.getName() + " : channel " + source.getName());
		System.out.println("--SERV-error>> "+message);
	}

	@Override
	public void transitionFired(String tname, String currentState, IService serv, String log, Exception ex) {
		System.out.println("--SERV>> "+serv.getName() + " : state " + currentState + " - " + tname + " . " + log);
		if (ex != null || tname.equals("")) {
			// System.err.println(ex);
			target.stop((ex == null ? "end" : ex.getMessage()));
			// FIXME : check exception type then assign responsibility
			// target.removeServiceListener(this);
			restoreChannels();
			// FIXME restoreScheduler();
			data.reset();
			generateReport();
		}
	}
}
